/***************************************************************************
 $RCSfile$
                             -------------------
    cvs         : $Id: crypttoken.h 1113 2007-01-10 09:14:16Z martin $
    begin       : Wed Mar 16 2005
    copyright   : (C) 2005 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *          Please see toplevel file COPYING for license details           *
 ***************************************************************************/


#ifndef GWEN_CRYPT_HASHALGO_H
#define GWEN_CRYPT_HASHALGO_H


#include <gwenhywfar/list2.h>


typedef struct GWEN_CRYPT_HASHALGO GWEN_CRYPT_HASHALGO;
GWEN_LIST2_FUNCTION_LIB_DEFS(GWEN_CRYPT_HASHALGO,
			     GWEN_Crypt_HashAlgo,
			     GWENHYWFAR_API)

typedef enum {
  GWEN_Crypt_HashAlgoId_Unknown=-1,
  GWEN_Crypt_HashAlgoId_None=0,
  GWEN_Crypt_HashAlgoId_Any,
  /** SHA-1 */
  GWEN_Crypt_HashAlgoId_Sha1,
  /** Ripemd 160 */
  GWEN_Crypt_HashAlgoId_Rmd160,
  /** MD-5 */
  GWEN_Crypt_HashAlgoId_Md5,
} GWEN_CRYPT_HASHALGOID;


#include <gwenhywfar/db.h>



GWEN_CRYPT_HASHALGOID GWEN_Crypt_HashAlgoId_fromString(const char *s);
const char *GWEN_Crypt_HashAlgoId_toString(GWEN_CRYPT_HASHALGOID a);


GWEN_CRYPT_HASHALGO *GWEN_Crypt_HashAlgo_new(GWEN_CRYPT_HASHALGOID id);
GWEN_CRYPT_HASHALGO *GWEN_Crypt_HashAlgo_dup(const GWEN_CRYPT_HASHALGO *a);
GWEN_CRYPT_HASHALGO *GWEN_Crypt_HashAlgo_fromDb(GWEN_DB_NODE *db);
int GWEN_Crypt_HashAlgo_toDb(const GWEN_CRYPT_HASHALGO *a, GWEN_DB_NODE *db);
void GWEN_Crypt_HashAlgo_Attach(GWEN_CRYPT_HASHALGO *a);
void GWEN_Crypt_HashAlgo_free(GWEN_CRYPT_HASHALGO *a);

GWEN_CRYPT_HASHALGOID GWEN_Crypt_HashAlgo_GetId(const GWEN_CRYPT_HASHALGO *a);
uint8_t *GWEN_Crypt_HashAlgo_GetInitVectorPtr(const GWEN_CRYPT_HASHALGO *a);
uint32_t GWEN_Crypt_HashAlgo_GetInitVectorLen(const GWEN_CRYPT_HASHALGO *a);
int GWEN_Crypt_HashAlgo_SetInitVector(GWEN_CRYPT_HASHALGO *a,
				      const uint8_t *pv,
				      uint32_t lv);



#endif

